Attribute VB_Name = "Functions"
Option Explicit

Public Declare Function ShellExecute Lib _
    "Shell32.dll" Alias "ShellExecuteA" _
    (ByVal hWnd As Long, _
    ByVal lpOperation As String, _
    ByVal lpFile As String, _
    ByVal lpParameters As String, _
    ByVal lpDirectory As String, _
    ByVal nShowCmd As Long) As Long
Public Declare Sub SHChangeNotify Lib _
    "Shell32.dll" (ByVal wEventId As Long, _
    ByVal uFlags As Integer, _
    ByVal dwItem1 As Any, _
    ByVal dwItem2 As Any)
Private Declare Sub CopyMemory Lib "Kernel32.dll" _
    Alias "RtlMoveMemory" ( _
    ByRef Destination As Any, _
    ByRef Source As Any, _
    ByVal Length As Long)

Public Const SHCNE_ASSOCCHANGED As Long = &H8000000
Public Const SHCNF_IDLIST  As Long = &H0
Function DirEx(ByVal Path As String, Filter As String, Attributes, Recurse As Boolean) As String
Dim Files() As String, lNum As Long, Folders() As String
If Right(Path, 1) <> "\" And Path <> "" Then Path = Path + "\"
ReDim Files(0) As String
Files(0) = Dir(Path + Filter, Attributes)
If Files(0) <> "" Then
    Do
    ReDim Preserve Files(UBound(Files) + 1) As String
    Files(UBound(Files)) = Dir
    Loop Until Files(UBound(Files)) = ""
    ReDim Preserve Files(UBound(Files) - 1) As String
End If
For lNum = 0 To UBound(Files)
    If Files(lNum) <> "" Then
        If IsDir(Path + Files(lNum)) = False And Not (Attributes And vbDirectory) Then
            DirEx = DirEx + Path + Files(lNum) + vbCrLf
        ElseIf IsDir(Path + Files(lNum)) = True And (Attributes And vbDirectory) Then
            DirEx = DirEx + Path + Files(lNum) + vbCrLf
        End If
    End If
Next lNum
If Recurse = True And (InStr(Filter, "?") > 0 Or InStr(Filter, "*") > 0) Then
    ReDim Folders(0) As String
    Folders(0) = Dir(Path, vbDirectory)
    If Folders(0) = "." Or Folders(0) = ".." Then Folders(0) = Dir
    If Folders(0) = "." Or Folders(0) = ".." Then Folders(0) = Dir
    If Folders(0) <> "" Then
        Do
        ReDim Preserve Folders(UBound(Folders) + 1) As String
        Folders(UBound(Folders)) = Dir
        If Folders(UBound(Folders)) = "." Or Folders(UBound(Folders)) = ".." Then
            ReDim Preserve Folders(UBound(Folders) - 1) As String
        End If
        Loop Until Folders(UBound(Folders)) = ""
        ReDim Preserve Folders(UBound(Folders) - 1) As String
    End If
    For lNum = 0 To UBound(Folders)
        If Folders(lNum) <> "" Then
            If IsDir(Path + Folders(lNum)) Then
                DirEx = DirEx + DirEx(Path + Folders(lNum), Filter, Attributes, Recurse)
            End If
        End If
    Next lNum
End If
End Function
Function FileExists(FileName As String) As Boolean
On Error GoTo NoFile
If (GetAttr(FileName) And vbDirectory) <> vbDirectory Then
    FileExists = True
Else
    FileExists = False
End If
Exit Function
NoFile:
FileExists = False
End Function
Function FindMpqHeader(MpqFile As String) As Long
Dim fNum As Long, Text As String, bNum As Long, MpqHead As Long
If FileExists(MpqFile) = False Then
    FindMpqHeader = -1
    Exit Function
End If
fNum = FreeFile
Open MpqFile For Binary As #fNum
For bNum = 1 To LOF(fNum) Step 2 ^ 20
    Text = String(2 ^ 20 + 32, Chr(0))
    If LOF(fNum) - bNum + 1 >= 2 ^ 20 + 32 Then
        Get #fNum, bNum, Text
    Else
        Text = String(LOF(fNum) - bNum + 1, Chr(0))
        Get #fNum, bNum, Text
    End If
    MpqHead = InStr(Text, "MPQ" + Chr(26))
CheckAgain:
    If MpqHead > 0 Then
        If JBytes(Text, MpqHead + 4, 4) >= 32 And JBytes(Text, MpqHead + 12, 2) = 0 Then
            Exit For
        Else
            MpqHead = InStr(MpqHead + 4, Text, "MPQ" + Chr(26))
            GoTo CheckAgain
        End If
    End If
Next bNum
Close #fNum
FindMpqHeader = bNum + MpqHead - 2
If MpqHead = 0 Then FindMpqHeader = -1
End Function
Function FullPath(ByVal BasePath As String, File As String) As String
If Right(BasePath, 1) <> "\" Then BasePath = BasePath + "\"
If Mid(File, 2, 1) = ":" Or Left(File, 2) = "\\" Then
    FullPath = File
ElseIf Left(File, 1) = "\" Then
    FullPath = Left(BasePath, 2) + File
Else
    FullPath = BasePath + File
End If
End Function
Function GetExtension(FileName As String) As String
Dim bNum As Long
If InStr(FileName, ".") > 0 Then
    For bNum = 1 To Len(FileName)
        If InStr(bNum, FileName, ".") > 0 Then
            bNum = InStr(bNum, FileName, ".")
        Else
            Exit For
        End If
    Next bNum
    GetExtension = Mid(FileName, bNum - 1)
Else
    GetExtension = ""
End If
End Function
Function GetNumMpqFiles(MpqFile As String) As Long
Dim fNum As Long, Text As String, MpqHeader As Long
fNum = FreeFile
Text = String(4, Chr(0))
MpqHeader = FindMpqHeader(MpqFile)
If MpqHeader > -1 Then
    Open MpqFile For Binary As #fNum
    Get #fNum, MpqHeader + 29, Text
    Close #fNum
    GetNumMpqFiles = JBytes(Text, 1, 4)
End If
End Function
Function IsDir(DirPath As String) As Boolean
On Error GoTo IsNotDir
If GetAttr(DirPath) And vbDirectory Then
    IsDir = True
Else
    IsDir = False
End If
Exit Function
IsNotDir:
IsDir = False
End Function
Function IsMPQ(MpqFile As String) As Boolean
Dim fNum As Long, Text As String, bNum As Long, MpqHead As Long
If FileExists(MpqFile) = False Then
    IsMPQ = False
    Exit Function
End If
fNum = FreeFile
Open MpqFile For Binary As #fNum
For bNum = 1 To LOF(fNum) Step 2 ^ 20
    Text = String(2 ^ 20 + 32, Chr(0))
    If LOF(fNum) - bNum + 1 >= 2 ^ 20 + 32 Then
        Get #fNum, bNum, Text
    Else
        Text = String(LOF(fNum) - bNum + 1, Chr(0))
        Get #fNum, bNum, Text
    End If
    MpqHead = InStr(Text, "MPQ" + Chr(26))
CheckAgain:
    If MpqHead > 0 Then
        If JBytes(Text, MpqHead + 4, 4) >= 32 And JBytes(Text, MpqHead + 12, 2) = 0 Then
            Exit For
        Else
            MpqHead = InStr(MpqHead + 4, Text, "MPQ" + Chr(26))
            GoTo CheckAgain
        End If
    End If
Next bNum
Close #fNum
IsMPQ = True
If MpqHead = 0 Then IsMPQ = False
End Function
Sub KillEx(ByVal Path As String, Filter As String, Attributes, Recurse As Boolean)
Dim Files() As String, lNum As Long, Folders() As String
If Right(Path, 1) <> "\" And Path <> "" Then Path = Path + "\"
ReDim Files(0) As String
Files(0) = Dir(Path + Filter, Attributes)
If Files(0) <> "" Then
    Do
    ReDim Preserve Files(UBound(Files) + 1) As String
    Files(UBound(Files)) = Dir
    Loop Until Files(UBound(Files)) = ""
    ReDim Preserve Files(UBound(Files) - 1) As String
End If
For lNum = 0 To UBound(Files)
    If Files(lNum) <> "" Then
        If IsDir(Path + Files(lNum)) = False Then
            On Error Resume Next
            Kill Path + Files(lNum)
            On Error GoTo 0
        End If
    End If
Next lNum
If Recurse = True And (InStr(Filter, "?") > 0 Or InStr(Filter, "*") > 0) Then
    ReDim Folders(0) As String
    Folders(0) = Dir(Path, vbDirectory)
    If Folders(0) = "." Or Folders(0) = ".." Then Folders(0) = Dir
    If Folders(0) = "." Or Folders(0) = ".." Then Folders(0) = Dir
    If Folders(0) <> "" Then
        Do
        ReDim Preserve Folders(UBound(Folders) + 1) As String
        Folders(UBound(Folders)) = Dir
        If Folders(UBound(Folders)) = "." Or Folders(UBound(Folders)) = ".." Then
            ReDim Preserve Folders(UBound(Folders) - 1) As String
        End If
        Loop Until Folders(UBound(Folders)) = ""
        ReDim Preserve Folders(UBound(Folders) - 1) As String
    End If
    For lNum = 0 To UBound(Folders)
        If Folders(lNum) <> "" Then
            If IsDir(Path + Folders(lNum)) Then
                KillEx Path + Folders(lNum), Filter, Attributes, Recurse
                On Error Resume Next
                RmDir Path + Folders(lNum)
            End If
            On Error GoTo 0
        End If
    Next lNum
End If
End Sub
Function MatchesFilter(FileName As String, ByVal Filters As String) As Boolean
Dim bNum As Long
If InStr(Filters, ";") Then
    If Right(Filters, 1) <> ";" Then Filters = Filters + ";"
    For bNum = 1 To Len(Filters)
        If LCase(FileName) Like LCase(Mid(Filters, bNum, InStr(bNum, Filters, ";") - bNum)) Then
            MatchesFilter = True
            Exit Function
        End If
        bNum = InStr(bNum, Filters, ";")
    Next bNum
Else
    If LCase(FileName) Like LCase(Filters) Then MatchesFilter = True
End If
End Function
Function IsNum(Valu As String) As Boolean
Dim Num As Integer
For Num = 1 To Len(Valu)
    If Asc(Mid(Valu, Num, 1)) < 48 Or Asc(Mid(Valu, Num, 1)) > 57 Then Exit Function
Next Num
If Len(Valu) > 0 Then IsNum = True
End Function
Function JBytes(Text As String, Start As Long, Length As Long)
Dim buffer() As Byte, NumData As Currency
If Start + Length - 1 > Len(Text) Then Length = Len(Text) - (Start - 1)
On Error Resume Next
ReDim buffer(Length - 1)
buffer = StrConv(Mid(Text, Start, Length), vbFromUnicode)
CopyMemory NumData, buffer(0), Length
On Error GoTo 0
JBytes = NumData * 10000
End Function
Function JBytesB(Text As Byte, Length As Long)
Dim bNum As Long, NumData As Currency
CopyMemory NumData, Text, Length
JBytesB = NumData * 10000
End Function
Function SBytes(Num, Start As Long, Length As Long) As String
Dim buffer() As Byte, NumData As Currency
If Start + Length > 8 Then Length = 8 - Start
On Error Resume Next
NumData = Num / 10000
ReDim buffer(7)
CopyMemory buffer(0), NumData, 8
On Error GoTo 0
SBytes = Mid(StrConv(buffer, vbUnicode), Start + 1, Length)
End Function
Function SBytesB(Num, Start As Long, Length As Long)
Dim buffer() As Byte, NumData As Currency
If Start + Length > 8 Then Length = 8 - Start
On Error Resume Next
NumData = Num / 10000
ReDim buffer(7)
CopyMemory buffer(0), NumData, 8
On Error GoTo 0
SBytesB = MidB(buffer, Start + 1, Length)
End Function
